package hu.bme.mit.mdsd.service.generator;

import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import service.Service;

@SuppressWarnings("all")
public class ServiceModelGenerator implements IGenerator {
  public void doGenerate(final Resource input, final IFileSystemAccess fsa) {
    EList<EObject> _contents = input.getContents();
    for (final EObject eObject : _contents) {
      this.compile(eObject, fsa);
    }
  }
  
  protected void _compile(final EObject m, final IFileSystemAccess fsa) {
  }
  
  protected void _compile(final service.System system, final IFileSystemAccess fsa) {
    EList<Service> _services = system.getServices();
    for (final Service service : _services) {
      this.compile(service, fsa);
    }
  }
  
  public void compile(final Service service, final IFileSystemAccess fsa) {
    String _name = service.getName();
    String _operator_plus = StringExtensions.operator_plus(_name, ".txt");
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Hello ");
    String _name_1 = service.getName();
    _builder.append(_name_1, "");
    _builder.append("!");
    fsa.generateFile(_operator_plus, _builder);
  }
  
  public void compile(final EObject system, final IFileSystemAccess fsa) {
    if (system instanceof service.System) {
      _compile((service.System)system, fsa);
    } else if (system != null) {
      _compile(system, fsa);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(system, fsa).toString());
    }
  }
}
